/** {̃eLXg當̎iȂj
  * E.
  * gFjava JpSubjectsAnalyzer inputfile >outfile
  * version 0.01  Aug. 2002  hiwa
  */
import java.io.*;
import java.util.*;

public class JpSubjectsAnalyzer{
  static final String JP_SENTENCE_DELIM_REGEXP = "B"; //EK\
  static final int MINIMUM_SENTENCE_LENGTH = 4; //͑Ώە̍ŒZij
  HashMap wordsAndCounts;

  public JpSubjectsAnalyzer(){
    wordsAndCounts = new HashMap();
  }

  /* ïʒu */
  public int getSubjIndex(String sentence){
    int start = 1; //͖
    int i = -1;

    if (sentence.length() < MINIMUM_SENTENCE_LENGTH){
      return -1;
    }
    
    while (start < (sentence.length() -1) 
     && (i = sentence.indexOf('', start)) != -1){
      if (! validChar(sentence.charAt(i - 1))){ //O̕OK?
        start = i + 1; //߂Ȃ𒲂ׂ
        i = -1;
      }
      else{
        break;
      }
    }
    if (i == -1){ //ǂ''Ȃ̂''T
      start = 1;
      while (start < (sentence.length() - 1)
       && (i = sentence.indexOf('', start)) != -1){
        if (! validChar(sentence.charAt(i - 1))){
          start = i + 1;
          i = -1;
        }
        else{
          break;
        }
      }
    }   
  return i;
  }

  /* Љ⊿p݂̂琬o */
  public String getSubject(String sentence, int subjIndex){
    char ch;
    StringBuffer sb = new StringBuffer();
    
    for(int i = subjIndex - 1; i >= 0; --i){
      if (validChar(ch = sentence.charAt(i))){ //LE
        sb.append(ch);
      }
      else{
        break; //for[vI
      }
    }
    // reverse()Ă悩I
    return (sb.length() > 0 ? (trimHead(sb.reverse())) : "");
  }

  /* ꓪ̃Xy[Xg~O */
  String trimHead(StringBuffer buf){
    char ch;
    int offset = 0;
    
    while ((ch = buf.charAt(offset)) == ' '
         || ch == 'E'){ //'E'UnicodełKATAKANAȂ̂!
      ++offset;
    }
    return (buf.substring(offset));
  }

  /* Љ, , ASCIIȂtrueԂ */
  boolean validChar(char c){
    return (JpCharacter.isKatakana(c)
         || JpCharacter.isKanji(c)
         || JpCharacter.isAsciiPrintable(c)
    );
  }

  /* HashMapɌbƏoJEgL^ */
  public void addWordOrCount(String word, Map mp){
    Integer iobj;

    if (mp.containsKey(word)){ //łɂ
      iobj = (Integer)(mp.get(word));
      iobj = new Integer(iobj.intValue() + 1); //JEgCNg
      mp.put(word, iobj);
    }
    else{
      mp.put(word, new Integer(1)); //̌̏߂Ă̓o^
    }
  }
  
  /* eXgpmain()\bh */
  public static void main(String[] args){
    String line, sentence, subject;
    String[] sentences;
    Iterator itr;
    
    if (args.length < 1){
      System.err.println("USAGE: java JpSubjectsAnalyzer filename");
      System.exit(1);
    }

    JpSubjectsAnalyzer jsa = new JpSubjectsAnalyzer();
    HashMap hm = jsa.wordsAndCounts;
    
    try{
      BufferedReader br = new BufferedReader(new FileReader(args[0]));
      while ((line = br.readLine()) != null){
        sentences = line.split(JP_SENTENCE_DELIM_REGEXP);
        List slist = Arrays.asList(sentences); //IteratorĝList
        itr = slist.iterator();
        while (itr.hasNext()){
          sentence = (String)(itr.next());
          int sidx = jsa.getSubjIndex(sentence);
          if (sidx > 0){
            subject = jsa.getSubject(sentence, sidx);
            if (subject != null && subject.length() > 0){
              jsa.addWordOrCount(subject, hm);
            } // inner if : o^
          } // outer if : 炵̂
        } // inner while : 'B'ŏIĂ镶ׂ
      } // outer while : t@C̊es=epOtǂ
    }catch(Exception e){
      e.printStackTrace();
    }
    Set set = hm.entrySet(); //ȉ,  \[gς݃f[^W鏬׍H
    ArrayList ar = new ArrayList(set); //܂ESet
    Collections.sort(ar, new IntValueComparator()); //pxɃ\[g
    itr = ar.iterator();
    while (itr.hasNext()){ //ł͒PɌʂo͂̂
      Map.Entry me = (Map.Entry)(itr.next());
      System.out.println((String)(me.getKey()) + " : " 
                          + (Integer)(me.getValue()));
    }
  } // main()
} // class
